﻿Imports System.Drawing.Drawing2D
Public Class Form1

    Inherits System.Windows.Forms.Form
#Region "Reflect Text"
    ' This sub reflects text around the baseline of the characters.
    '   This is the first example that requires careful measurement of 
    '   the text, and is more advanced than most of the other examples.
    Private Sub Draw_Reflect_Text()
        Dim text_size As SizeF
        Dim grafx As Graphics
        Dim back_brush As Brush = Brushes.Gray
        Dim fore_brush As Brush = Brushes.Black
        Dim Fnt As New Font("Microsoft Sans Serif", NumericUpDown1.Value, FontStyle.Regular)
        Dim my_state As GraphicsState 'STORE THE CURRENT STATE OF GRAPHICS
        Dim x_location, y_location As Single 'USED FOR THE LOCATION
        Dim text_height As Single

        'CREATE A GRAPHICS OBJECT IN THE PICTURE BOX
        grafx = PictureBox1.CreateGraphics()
        'CLEAR THE GRAPHIC OBJECT
        grafx.Clear(Color.White)

        'SIZE IS REQUIRED TO DRAW THE TEXT
        text_size = grafx.MeasureString(TextBox1.Text, Fnt)

        'ELIMINATE THE REDUNDANT CALCULATIONS AFTER THE LOCATIONS' ONCE GET 
        x_location = (PictureBox1.Width - text_size.Width) / 2
        y_location = (PictureBox1.Height - text_size.Height) / 2

        'IN SCALING THE ENTIRE GRAPHIC OBJECTS, WE NEED TO REPOSITION THE ORIGIN OF 
        'IT (0,0) TO THE (xLocation, yLocation) POINT.
        'IF NOT, WHEN YOU FLIP THE TEXT WITH A SCALING TRANSFORM, 
        'IT WILL DRAW REFLECTED TEXT AT (xLocation, -yLocation)THAT IS OUTSITDE THE VIEWABLE AREA
        grafx.TranslateTransform(x_location, y_location)

        Dim line_ascent As Integer
        Dim line_spacing As Integer
        Dim line_height As Single

        'USE GETCELLASCENT TO CALCULATE THE HIEGHT ABOVE THE BASELINE.
        'SINCE IT RETURNS A DESIGN METRIC VALUE YOU HAVE TO CONVERT IT 
        'INTO PIXELS AND SCALED FOR THE FORMNT SIZE.
        line_ascent = Fnt.FontFamily.GetCellAscent(Fnt.Style)
        line_spacing = Fnt.FontFamily.GetLineSpacing(Fnt.Style)
        line_height = Fnt.GetHeight(grafx)
        text_height = line_height * line_ascent / line_spacing

        'THIS REFLECTS OVER THE LOWEST PORTION OF THE TEXT.
        Dim line_descent As Integer 'REFLECT TO THE DESCENDING CHARACTERS 
        line_descent = Fnt.FontFamily.GetCellDescent(Fnt.Style)
        text_height = line_height * (line_ascent + line_descent) / line_spacing


        'DRAW THE REFLECTED ONE FIRST TO DEMONSTRATE THE USE OF GRAPHICS STATE OBJECT.
        'A GRAPHICSSTATE OBJECT MAINTAINS THE GRAPHICS OBJECT.

        'GRAPHICSSTATE SAVE FIRST.
        my_state = grafx.Save()

        'USE THE SCALETRANSFORM WITH A NEGATIVE VALUE TO DRAW THE REFLECTIION 
        'AND USING -1 THE REFLECTED TEXT WILL NOT DISTORT.
        grafx.ScaleTransform(1, -1.0F) ' REFLECTING THE Y DIRECTION 
        grafx.DrawString(TextBox1.Text, Fnt, back_brush, 0, -text_height)

        'BEFORE IT TRANFORM RESET THE GRAPHICS STATE
        grafx.Restore(my_state)

        'MAIN TEXT DRAWN.
        grafx.DrawString(TextBox1.Text, Fnt, fore_brush, 0, -text_height)

    End Sub
#End Region

    'CREATE A SUB PROCEDURE FOR THE NAME OF THE EFFECTS.
    'ADDING THE ITEMS IN THE COMBO BOX.
    Private Sub effectlist()
        With ComboBox1.Items
            .Clear()
            .Add("Reflect")
        End With
    End Sub
    '
    Private Sub draw_text()
        effectlist()
        If ComboBox1.SelectedItem Is Nothing Then
            ComboBox1.SelectedIndex = 0
        End If
        Select Case ComboBox1.SelectedItem.ToString()
            Case "Reflect"
                Draw_Reflect_Text()
        End Select
    End Sub
    Private Sub UIChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
        Handles TextBox1.TextChanged, NumericUpDown1.ValueChanged, PictureBox1.MouseHover
        If NumericUpDown1.Value = 0 Then
            NumericUpDown1.Value = 50
        End If
        draw_text()
    End Sub
End Class
 
